#+PROPERTY: header-args :tangle font-preview.el

:README:
To compile correctly with LuaTeX (and latexmk) from Org I have in my
init:

#+begin_src emacs-lisp :tangle no
(setq org-latex-pdf-process
      '("latexmk -lualatex -output-directory=%o -e '$lualatex=q/lualatex %%O -shell-escape %%S/' %f"))
#+end_src

For the preview with LuaTeX, I use imagemagick, and also have this code in my init:

#+begin_src emacs-lisp :tangle no
    (setq luamagick
	  '(luamagick
	    :programs ("lualatex" "convert")
	    :description "pdf > png"
	    :message "you need to install lualatex and imagemagick."
	    :use-xcolor t
	    :image-input-type "pdf"
	    :image-output-type "png"
	    :image-size-adjust (1.0 . 1.0)
	    :latex-compiler ("lualatex -interaction nonstopmode -output-directory %o %f")
	    :image-converter ("convert -density %D -trim -antialias %f -quality 100 %O")))

    (add-to-list 'org-preview-latex-process-alist luamagick)

    (setq org-preview-latex-default-process 'luamagick)
#+end_src
:END:

#+begin_src emacs-lisp
;;; -*- lexical-binding: t; -*-
#+end_src

#+begin_src emacs-lisp :results silent
  (setq otf-features (regexp-opt '( "abvf"   "abvm"   "abvs"   "aalt"   "akhn"
       "nalt"   "halt"   "afrc"   "valt"   "vhal"   "blwf"   "blwm"   "blws"   "cpsp"   "c2pc"   "c2sc"
       "case"   "cpct"   "cv01"   "cv02"   "cv03"   "cv04"   "cv05"   "cv06"   "cv07"   "cv08"   "cv09"
       "cv10"   "cv11"   "cv12"   "cv13"   "cv14"   "cv15"   "cv16"   "cv17"   "cv18"   "cv19"   "cv20"
       "cv21"   "cv22"   "cv23"   "cv24"   "cv25"   "cv26"   "cv27"   "cv28"   "cv29"   "cv30"   "cv31"
       "cv32"   "cv33"   "cv34"   "cv35"   "cv36"   "cv37"   "cv38"   "cv39"   "cv40"   "cv41"   "cv42"
       "cv43"   "cv44"   "cv45"   "cv46"   "cv47"   "cv48"   "cv49"   "cv50"   "cv51"   "cv52"   "cv53"
       "cv54"   "cv55"   "cv56"   "cv57"   "cv58"   "cv59"   "cv60"   "cv61"   "cv62"   "cv63"   "cv64"
       "cv65"   "cv66"   "cv67"   "cv68"   "cv69"   "cv70"   "cv71"   "cv72"   "cv73"   "cv74"   "cv75"
       "cv76"   "cv77"   "cv78"   "cv79"   "cv80"   "cv81"   "cv82"   "cv83"   "cv84"   "cv85"   "cv86"
       "cv87"   "cv88"   "cv89"   "cv90"   "cv91"   "cv92"   "cv93"   "cv94"   "cv95"   "cv96"   "cv97"
       "cv98"   "cv99"   "cjct"   "cfar"   "calt"   "clig"   "cswh"   "curs"   "dnom"   "dlig"   "dist"
       "expt"   "falt"   "frac"   "fwid"   "ccmp"   "haln"   "half"   "hwid"   "hngl"   "hist"   "hlig"
       "hkna"   "hojo"   "init"   "isol"   "ital"   "jp04"   "jp78"   "jp83"   "jp90"   "jalt"   "kern"
       "lnum"   "ljmo"   "lfbd"   "ltra"   "ltrm"   "locl"   "mark"   "mset"   "mkmk"   "mgrk"   "medi"
       "med2"   "nlck"   "nukt"   "numr"   "onum"   "opbd"   "size"   "ordn"   "ornm"   "pcap"   "pref"
       "pres"   "psts"   "pstf"   "palt"   "vpal"   "pnum"   "pkna"   "pwid"   "qwid"   "rand"   "rkrf"
       "rphf"   "rlig"   "rtbd"   "rtla"   "rtlm"   "ruby"   "sinf"   "smpl"   "zero"   "smcp"   "liga"
       "salt"   "ss01"   "ss02"   "ss03"   "ss04"   "ss05"   "ss06"   "ss07"   "ss08"   "ss09"   "ss10"
       "ss11"   "ss12"   "ss13"   "ss14"   "ss15"   "ss16"   "ss17"   "ss18"   "ss19"   "ss20"   "subs"
       "sups"   "swsh"   "tnum"   "fina"   "fin2"   "fin3"   "twid"   "titl"   "trad"   "tnam"   "tjmo"
       "unic"   "vatu"   "vert"   "vrt2"   "vkna"   "vkrn"  "vjmo")))
#+end_src

#+begin_src emacs-lisp
(setq my-dired-preview-font-specimen-dir "/path/to/the/specimen/file/")
#+end_src

#+NAME: specimen
#+begin_src latex :tangle specimen.tex
\parindent=0em\raggedright

    AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz? \par

    1234567890\par

    {\addfontfeature{Numbers=Lowercase}1234567890\par} Åå Çç Øø\\ Ẽẽ Ĩĩ Ũũ Ỹỹ \par IPA:
  ʔǝŋɲɾʧɨɔɛʃʤɸɣβɡɑɐɒʙðɕʑɻɚ\par greek: ΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩ\par
  αβγδεζηθικλμνξοπρσςτυφχψω \par

    Ligatures:

   fluffier soufflé fisticuffs fb fh ffh fj ffj fk ffk ft fft tt Qu Th ch ck ct \par

    \textsc{Some small caps...}\par

    \vspace{1em}

    Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Donec hendrerit tempor tellus.
  Donec pretium posuere tellus. Proin quam nisl, tincidunt et, mattis eget, convallis nec,
  purus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus
  mus. Nulla posuere. Donec vitae dolor. Nullam tristique diam non turpis. Cras placerat
  accumsan nulla. Nullam rutrum. Nam vestibulum accumsan nisl. Lorem ipsum dolor sit amet,
  consectetuer adipiscing elit. Donec hendrerit tempor tellus. \par

    \vspace{1em}

  \foreignlanguage{greek}{% βουλεύεται ὅπως μήποτε ἔτι ἔσται ἐπὶ τῷ ἀδελφῷ, ἀλλά, ἢν
  δύνηται, βασιλεύσει ἀντ᾽ ἐκείνου. Παρύσατις μὲν δὴ ἡ μήτηρ ὑπῆρχε τῷ Κύρῳ, φιλοῦσα αὐτὸν
  μᾶλλον ἢ τὸν βασιλεύοντα Ἀρταξέρξην. ὅστις δ᾽ ἀφικνεῖτο τῶν παρὰ βασιλέως πρὸς αὐτὸν
  πάντας οὕτω διατιθεὶς ἀπεπέμπετο ὥστε αὐτῷ μᾶλλον φίλους εἶναι ἢ βασιλεῖ. καὶ τῶν παρ᾽
  ἑαυτῷ δὲ βαρβάρων ἐπεμελεῖτο ὡς πολεμεῖν τε ἱκανοὶ εἴησαν καὶ εὐνοϊκῶς ἔχοιεν αὐτῷ. τὴν δὲ
  Ἑλληνικὴν δύναμιν ἥθροιζεν ὡς μάλιστα ἐδύνατο ἐπικρυπτόμενος, ὅπως ὅτι ἀπαρασκευότατον
  λάβοι βασιλέα.\par

    \vspace{1em}

  \foreignlanguage{russian}{%
И въ 1506 року первый былъ гетманъ войскъ запорожскихъ изъ фамиліи сенаторской именуемый
Прецславъ Лянцкронскій. Сей многократно землю Турецкую съ козаками щастливо воевалъ. За
сего гетмана и за короля полскаго Жикгимонта I козакамъ за службы ихъ давано волности и
привернено землю, которую король полскій Казимиръ I, въ року 1340, заобладавши, изъ
княженія Кіевскаго воеводство учинилъ, выше и низше пороговъ по обоихъ сторонахъ Днѣпра во
владѣніе вѣчное, дабы Туркамъ и Татарамъ на Рускую землю козаки нападать не допускали.}
#+end_src

#+begin_src emacs-lisp :results silent
  (setq  my-dired-preview-font-options-list '((?1 "Glyph(s)" (lambda ()
							       (interactive)
							       (format "%s" (read-from-minibuffer "Insert a string: "))))
					      (?2 "Code" (lambda ()
							   (interactive)
							   (let ((chars (read-from-minibuffer
									 "Insert character(s) by code (i.e. \"006f\", 1 space between each code; \"|\" = word sep.): ")))
							     (replace-regexp-in-string
							      "|" " "
							      (replace-regexp-in-string
							       "\s*\\([[:alnum:]]+\\)\s*" "{^^^^\\1}"
							       chars)))))
					      (?3 "Print specimen" (lambda ()
								     (interactive)
								     (with-temp-buffer
								       (insert-file-contents (concat my-dired-preview-font-specimen-dir "specimen.tex"))
								       (buffer-string))))))
#+end_src

#+begin_src emacs-lisp :results silent
  (defun choice-glyphs-or-code ()
    (interactive)
    (let ((opt (read-char-choice (concat "Preview code or string >>\n\n"
					 (mapconcat (lambda (item)
						      (format "%c: %s"
							      (car item) (nth 1 item)))
						    my-dired-preview-font-options-list " --- "))
				 (mapcar #'car my-dired-preview-font-options-list))))
      (funcall (nth 2
		    (assoc
		     opt
		     my-dired-preview-font-options-list)))))
#+end_src


#+begin_src emacs-lisp :results silent
  (require 'button)

  (defun my-dired-preview-font-at-point ()
    "TODO"
    (interactive)
    (let* ((font (file-name-nondirectory (dired-get-file-for-visit)))
	   (path (file-name-directory (dired-get-file-for-visit)))
	   (specs-otfinfo
	    (split-string
	     (shell-command-to-string
	      (concat "otfinfo -f "
		      (shell-quote-argument (dired-get-file-for-visit))))
	     "\n"))
	   (string (choice-glyphs-or-code))
	   (size (read-from-minibuffer "Font size in points (default 18pt): " nil nil t t "18"))
	   (interline (read-from-minibuffer "Interline in points (default 21.6pt): " nil nil t t "21.6"))
	   (opentype-feature (read-from-minibuffer "Opentype features (default none): " nil nil t t "[]"))
	   (doc (concat
		 "\n\\begin{null}\n"
		 (format "\\fontsize{%spt}{%spt}\\selectfont\n" size interline)
		 string
		 "\n\\end{null}\n")))
      (setq org-format-latex-header (concat "\\documentclass[varwidth]{standalone}\n"
					    "\\usepackage{xcolor}\n"
					    "\[PACKAGES]
					    \[DEFAULT-PACKAGES]"
					    "\n\\pagestyle{empty}"
					    "\n\\usepackage{fontspec}"
					    "\n\\usepackage[spanish,english]{babel}"
					    "\n\\setmainfont{"
					    font
					    "}[Path="
					    path
					    (if (not (equal opentype-feature "[]"))
						(format ",RawFeature={%s}" opentype-feature)
					      "")
					    "]"
					    "\\pagestyle{empty}"))
      (when (get-buffer "*font-preview*")
	(kill-buffer "*font-preview*"))
      (get-buffer-create "*font-preview*")
      (set-buffer "*font-preview*")
      (org-mode)
      (mapc (lambda (el)
	      (let ((spec (when (string-match (concat "\\(" otf-features "\\)") el)
			    (match-string 1 el))))
		(insert-button (format "%s\n" el)
			       'action (lambda (x)
					 (org-clear-latex-preview (point-min) (point-max))
					 (goto-char (point-min))
					 (read-only-mode -1)
					 (re-search-forward "\\(\\\\begin{null}\\)\\(\n\\\\addfontfeature.+\\)?" nil t)
					 (replace-match (concat "\\1\n\\\\addfontfeature{RawFeature=" spec "}") t nil)
					 (org-latex-preview)))))
	    specs-otfinfo)
      (insert "\n\n")
      (insert doc)
      (org-latex-preview)
      (temp-buffer-window-show "*font-preview*")))
#+end_src
